package it.unina.dsf.knomelab;


import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.Assert;

// JMock Import
import org.jmock.Expectations;
import org.jmock.Mockery;
import org.jmock.integration.junit4.JMock;
import org.jmock.integration.junit4.JUnit4Mockery;

@RunWith(JMock.class)
public class StackTest {

	private Stack stack;
	private final Mockery context = new JUnit4Mockery();
	private final ISupervisor supervisor = context.mock(ISupervisor.class, "supervisor");
	@Before
	public void setUp() throws Exception {
		this.stack = new Stack();
	}
	
	@Test
	public void testStackInitialization(){
		int expected_value = 0;
		Assert.assertEquals(expected_value, this.stack.get_current_dimension());
	}
	
	@Test
	public void pushAnElementIntoTheStack(){
		int expected_value = 1;
		this.stack.setSupervisor(this.supervisor);
		context.checking(new Expectations() {{
			atMost(1).of(supervisor).countPushes();
		}});
		this.stack.push(55);
		Assert.assertEquals(expected_value, this.stack.get_current_dimension());
	}

}
